//--------------------------------------------------------------------//
// tN^(DLA)

var canvas;			// LoXvf
var context;	 		// ReLXg
var image;			// 摜
var pixel;			// 摜sNZf[^
var pmap=[];			// q
var width,height;		// f[^̈敝E
var p=[];			// qXg
var bgColor=[0,0,0,255];	// wiF
var onColor=[255,255,255,255];	// ÏW̕\F
var pColor=[0,0,153,255];	// Vq\F
var acc;			// W

// q̏
var NO=0;		// qȂ
var WANDER=1;		// V
var FIX=-1;		// Œ

// q̈ړ
var UP=0;
var DOWN=1;
var LEFT=2;
var RIGHT=3;

// `Jn
// a - W@w莞0w莞̃ftHg30
function drawStart(a){
  acc=a||30;
  initCanvas();
  initParticles();
  loop();
}

// LoX
function initCanvas(){
  canvas=document.getElementById('dla');
  width=canvas.clientWidth;
  height=canvas.clientHeight;
  canvas.width=width;
  canvas.height=height;
  context=canvas.getContext('2d');
  image=context.createImageData(width,height);
  pixel=image.data;
  var size=width*height;
  for(var i=0;i<size;i++){
    pmap.push(NO);
    for(var j=0;j<4;j++) pixel[4*i+j]=bgColor[j];
  }
}

// q
function initParticles(){
  var phalf=2*width-2;
  for(var i=0;i<width-1;i++){
    p[i]=new Particle(i,0);
    p[i+width-1]=new Particle(i+1,height-1);
  }
  for(i=0;i<height-1;i++){
    p[i+phalf]=new Particle(0,i+1);
    p[i+phalf+height-1]=new Particle(width-1,i);
  }
  var cc=parseInt(width*(height+1)/2);
  pmap[cc]=FIX;
  for(i=0;i<4;i++) pixel[4*cc+i]=onColor[i];
}

// [v֐
var step=0,req;
function loop(){
  step++;
  for(var i=0;i<acc;i++) nextStep();
  context.putImageData(image,0,0);
  if(p.length===0){
    cancelAnimationFrame(req);
  }
  else{
    req=requestAnimationFrame(loop);
  }
}

// ̃XebvvZ
function nextStep(){
  var j,pp;
// qUʂ珜
  for(var i=0;i<p.length;i++){
    pp=p[i].p();
    if(pmap[pp]==WANDER){
      pmap[pp]=NO;
      for(j=0;j<4;j++) pixel[4*pp+j]=bgColor[j];
    }
  }
  for(i=p.length-1;i>=0;i--){
    p[i].randomWalk();
    pp=p[i].p();
// jɐڐGꍇ
    if(checkAdd(p[i])){
      pmap[pp]=FIX;
      for(j=0;j<4;j++) pixel[4*pp+j]=onColor[j];
      p.splice(i,1);
    }
// Vꍇ
    else{
      pmap[pp]=WANDER;
      for(j=0;j<4;j++) pixel[4*pp+j]=pColor[j];
    }
  }
}

// qÏW邩ǂ肷
function checkAdd(p){
  var index=p.p();
  if(pmap[index]===FIX) return false;
  if(p.x===0){
    if(pmap[index+1]===FIX) return true;
  }
  else if(p.x===width-1){
    if(pmap[index-1]===FIX) return true;
  }
  else{
    if((pmap[index-1]===FIX) || (pmap[index+1]===FIX)){
      return true;
    }
  }
  if(p.y===0){
    if(pmap[index+width]===FIX) return true;
  }
  else if(p.y===height-1){
    if(pmap[index-width]===FIX) return true;
  }
  else{
    if((pmap[index-width]===FIX) || (pmap[index+width]===FIX)){
      return true;
    }
  }
  return false;
}

//--------------------------------------------------------------------//
// q
// x,y - x,yW
var Particle=function(x,y){
  this.x=x;
  this.y=y;
};

// ʒu|C^Ԃ
Particle.prototype.p=function(){
  return width*this.y+this.x;
};

// q_EH[N
Particle.prototype.randomWalk=function(){
  var dir=Math.floor(4*Math.random());
  switch(dir){
    case UP:
      if(this.y===0) this.y++;
      else           this.y--;
      break;
    case DOWN:
      if(this.y===height-1) this.y--;
      else                  this.y++;
      break;
    case LEFT:
      if(this.x===0) this.x++;
      else           this.x--;
      break;
    case RIGHT:
      if(this.x===width-1) this.x--;
      else                 this.x++;
      break;
  }
};

// qړ
// dir - ړ
Particle.prototype.move=function(dir){
  switch(dir){
    case UP:
      this.y--;
      break;
    case DOWN:
      this.y++;
      break;
    case LEFT:
      this.x--;
      break;
    case RIGHT:
      this.x++;
      break;
  }
};
